unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, RXGrids, uNemo;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    Panel1: TPanel;
    btnLoad: TButton;
    grdNemo: TRxDrawGrid;
    btnSolve: TButton;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    edtWidth: TEdit;
    Label2: TLabel;
    edtHeight: TEdit;
    btnMakeNew: TButton;
    btnRowStep: TButton;
    btnColStep: TButton;
    Label3: TLabel;
    procedure btnLoadClick(Sender: TObject);
    procedure grdNemoDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnSolveClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnRowStepClick(Sender: TObject);
    procedure btnColStepClick(Sender: TObject);
    procedure grdNemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Nemo: TNemo;
    m_nCurCol, m_nCurRow: Integer;
    procedure ResizeGrid;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses IniFiles;

{$R *.dfm}

procedure TForm1.btnLoadClick(Sender: TObject);
var
  NumOfX, NumOfY: Integer;
  Ini: TIniFile;
begin
  OpenDialog1.InitialDir := ExtractFileDir(ParamStr(0));
  if not OpenDialog1.Execute then
  begin
    Exit;
  end;

  if Assigned(Nemo) then
  begin
    Nemo.Free;
  end;

  grdNemo.Visible := True;
  Ini := TIniFile.Create(OpenDialog1.FileName);
  Nemo := TNemo.Create(Ini);
  with grdNemo do
  begin
    ColCount := Nemo.Col + Nemo.DCol + 1;
    RowCount := Nemo.Row + Nemo.DRow + 1;
  end;
  ResizeGrid;
  Ini.Free;
end;

procedure TForm1.grdNemoDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  col1, row1: Integer;
begin
{}
//OutputDebugString(PChar(Format('%d, %d, (%d,%d,%d,%d)', [ACol, ARow, Rect.Left, Rect.Top, rect.Right, rect.Bottom])));
  if not Assigned(Nemo) then Exit;

  with grdNemo do
  begin
    if ((ACol > 0) and (ACol <= Nemo.DCol) and (ARow >= Nemo.DRow+1))
      or ((ARow > 0) and (ARow <= Nemo.DRow) and (ACol >= Nemo.DCol+1)) then
    begin
      //Canvas.Brush.Color := clYellow;
      //Canvas.FillRect(Rect);
      if (ACol <= Nemo.DCol) then
      begin
        if (m_nCurRow = ARow) then
          Canvas.Brush.Color := clLime
        else
          Canvas.Brush.Color := clYellow;
        Canvas.FillRect(Rect);

        row1 := ARow-Nemo.DRow-1;
        col1 := ACol - Nemo.DCol + Nemo.RowDigits[ row1 ].Count - 1;
        if col1 >= 0 then
          Canvas.TextRect(Rect, Rect.Left+1, Rect.Top+1, IntToStr(Nemo.RowDigits[ row1 ].Item[col1]));
      end;

      if (ARow <= Nemo.DRow) then
      begin
        if (m_nCurCol = ACol) then
          Canvas.Brush.Color := clLime
        else
          Canvas.Brush.Color := clYellow;
        Canvas.FillRect(Rect);

        col1 := ACol-Nemo.DCol-1;
        row1 := ARow - Nemo.DRow + Nemo.ColDigits[ col1 ].Count - 1;
        if row1 >= 0 then
          Canvas.TextRect(Rect, Rect.Left+1, Rect.Top+1, IntToStr(Nemo.ColDigits[ col1 ].Item[row1]));
      end;
    end
    else if (ARow >= Nemo.DRow + 1) and (ACol >= Nemo.DCol + 1) then
    begin
      row1 := ARow-Nemo.DRow-1;
      col1 := ACol-Nemo.DCol-1;
      case Nemo.Board[row1][col1] of
      'O'://nbsGray:
        begin
          Canvas.Brush.Color := clWhite;
          Canvas.FillRect(Rect);
        end;
      '#'://nbsBlack:
        begin
          Canvas.Brush.Color := clBlack;
          Canvas.FillRect(Rect);
        end;
      '.'://nbsWhite:
        begin
          Canvas.Pen.Color := clGray;
          Canvas.Brush.Color := clWhite;
          Canvas.FillRect(Rect);
          Canvas.MoveTo(Rect.Left, Rect.Top);
          Canvas.LineTo(Rect.Right, Rect.Bottom);
          Canvas.MoveTo(Rect.Right, Rect.Top);
          Canvas.LineTo(Rect.Left, Rect.Bottom);
        end;
      end;
      if gdSelected in State then
      begin
        Canvas.Pen.Color := clBlue;
        Canvas.Brush.Style := bsClear;
        Canvas.Rectangle(Rect);
        Canvas.Rectangle(Rect.Left+1, Rect.Top+1, Rect.Right-1, Rect.Bottom-1);
      end;
    end
    else
    begin
      Canvas.Brush.Color := clWhite;
      Canvas.FillRect(Rect);
    end;

  end;
//  grdNemo.Canvas.Rectangle(Rect.Left+2, Rect.Top+2, rect.Right-2, rect.Bottom-2);
{}
end;

procedure TForm1.btnSolveClick(Sender: TObject);
var
  nTotal: Integer;
  nWhite, nBlack: Integer;
  nPrevWhite, nPrevBlack: Integer;
  bDone: Boolean;
  nCount: Integer;
begin
  nPrevWhite := 0;
  nPrevBlack := 0;
  nTotal := Nemo.Col * Nemo.Row;
  bDone := False;
  nCount := 0;

  while not bDone do
  begin
    if (nCount mod 2) = 0 then
      Nemo.ProcessAllCol
    else
      Nemo.ProcessAllRow;
    grdNemo.Refresh;
    Nemo.GetScore(nWhite, nBlack);
    if nWhite+nBlack = nTotal then
    begin
      // ذ
      bDone := True;
    end
    else if (nWhite < nPrevWhite) or (nBlack < nPrevBlack) then
    begin
      // , ߸ 
      bDone := True;
    end
    else if (nWhite = nPrevWhite) and (nBlack = nPrevBlack) then
    begin
      // ,  
      bDone := True;
    end;
    nPrevWhite := nWhite;
    nPrevBlack := nBlack;
    Inc(nCount);
  end;
end;

procedure TForm1.ResizeGrid;
begin
  with grdNemo do
  begin
    DefaultColWidth := Width div ColCount - 1;
    DefaultRowHeight := Height div RowCount - 1;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  ResizeGrid;
end;

procedure TForm1.btnRowStepClick(Sender: TObject);
begin
  Nemo.ProcessAllRow;
  grdNemo.Refresh;
end;

procedure TForm1.btnColStepClick(Sender: TObject);
begin
  Nemo.ProcessAllCol;
  grdNemo.Refresh;
end;

procedure TForm1.grdNemoMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Col, Row: Integer;
begin
  col := X div (grdNemo.DefaultColWidth + grdNemo.GridLineWidth);
  row := Y div (grdNemo.DefaultRowHeight + grdNemo.GridLineWidth);

  Label3.Caption := Format('(%d) %d, %d', [grdNemo.DefaultColWidth, x, y]);
  if (Row >= Nemo.DRow + 1) and (Col >= Nemo.DCol + 1) then
  begin
    m_nCurCol := col;
    m_nCurRow := row;
    grdNemo.Refresh;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := true;
  m_nCurCol := -1;
  m_nCurRow := -1;
end;

end.
